#!/usr/bin/perl -w -I ../_lib -I ../_sal -I ../_config

# -----------------------------------------------------------------------------
use strict;

use CGI;
use CGI::Carp qw(fatalsToBrowser);

use client_bits;
use cookies;
use exceptions;

use admin_add_a_branch;

# -----------------------------------------------------------------------------
# INIT :

my $query = new CGI;
    # ...get pointer to CGI ENV, then extract stuff :

my $TREE        = $query->param('TREE');
my $USERNAME    = $query->param('USERNAME');
my $LOCATION    = $query->param('LOCATION');
my $NEWBRANCH   = $query->param('NEWBRANCH');
my $README      = $query->param('README');
my $ALLOW       = $query->param('ALLOW');
my $DENY        = $query->param('DENY');

my $SUBMITLOCATION = $query->param('SUBMITLOCATION');
my $SELECTLOCAT    = $query->param('SELECTLOCAT');
my $ACTUALLYADD    = $query->param('ACTUALLYADD');


# -----------------------------------------------------------------------------
# -- clean up input (e.g., eliminate spaces) : 

$NEWBRANCH = &clean_name($NEWBRANCH);


# -----------------------------------------------------------------------------
# -- BEGIN HTML/PAGE :

&begin_html("", "Admin-Tool:  Add a User");
&print_simple_header();


# -----------------------------------------------------------------------------
# -- VALIDATE :

unless (&valid_admin_cookie()) {
    &raise_logout_exception("invalid_cookie")
  }


# -----------------------------------------------------------------------------
# -- ACTUALLY DO STUFF :


if ($SELECTLOCAT eq "yes") {
    &print_select_location_form($TREE, $USERNAME);
  }
elsif ($ACTUALLYADD eq "yes") {
    &actually_add_branch($TREE, $LOCATION, $NEWBRANCH, $README, 
                         $ALLOW, $DENY, $USERNAME);
  }
elsif ($SUBMITLOCATION eq "Delete this branch...") {
    &actually_delete_branch($TREE, $LOCATION, $USERNAME);
  }
elsif ($SUBMITLOCATION eq "Add at this branch...") {
    &print_add_branch_form($TREE, $LOCATION, $USERNAME);
  }


# -----------------------------------------------------------------------------
# -- TEA-TIME :

&print_std_footer;
&end_html;
# -----------------------------------------------------------------------------
