# -----------------------------------------------------------------------------
package admin_add_a_branch;
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# History :
# 
# -- 2001 Feb 20: 
#          
# -- 
# 
# -----------------------------------------------------------------------------

use strict;
use vars qw(@ISA @EXPORT);

use admin_bits;

use config;
use debug;
use exceptions;

use CDF;

# -----------------------------------------------------------------------------

require Exporter;

@ISA = qw(Exporter);
@EXPORT = qw(print_select_location_form
             print_add_branch_form
             actually_add_branch
             actually_delete_branch
             clean_name);

# -----------------------------------------------------------------------------
# -- MODULE/PACKAGE VARS :
# -----------------------------------------------------------------------------

my $root         = &root;
my $html_lib_dir = &html_lib_dir;

# -----------------------------------------------------------------------------
# -- EXPORTS :

sub print_select_location_form() {

  my $TREE     = shift;
  my $USERNAME = shift;

print "\n<BR> TREE: $TREE";
print "\n<BR> USERNAME: $USERNAME";

    my $textline;
###    my @branches = &current_branches($TREE, "");
    my $cdf = CDF->new($TREE, "/");
    my $branches = $cdf->rec_childs($TREE, "");
    my $branch_selector = "<B>Available Branches: </B>";
  
    $branch_selector = "<SELECT NAME=\"LOCATION\" SIZE=1>\n";
###    foreach (@branches) {$branch_selector .= "<OPTION>$_\n";}
    $branch_selector .= "<OPTION>/\n";
    foreach (@$branches) {$branch_selector .= "<OPTION>$_\n";}
    $branch_selector .= "</SELECT>\n"; 

    open (FORM, "$html_lib_dir/admin_select_location_form.html_src")
        || &raise_stop_exception("Can't open admin_select_location_form");

    while($textline = <FORM>) {
        $textline =~ s/%tree%/$TREE/;
        $textline =~ s/%username%/$USERNAME/;
        $textline =~ s/%branchselector%/$branch_selector/;
        print $textline;
      }

    close (FORM);
  }


# -----------------------------------------------------------------------------

sub print_add_branch_form() {

  my $TREE     = shift;
  my $LOCATION = shift;
  my $USERNAME = shift;

    my $root = &root;
    my $textline;

    my $users_allow = "";
    my $users_deny = "";

print "\n<BR> TREE: $TREE";
print "\n<BR> USERNAME: $USERNAME";

    # -- get default users.allow and users.deny from current CDF :
    open (ALLOW, "$root/$TREE/$LOCATION/USERS.ALLOW")
        || &raise_stop_exception("Can't open $root/$TREE/$LOCATION/" . 
                                 "USERS.ALLOW");
    while ($textline = <ALLOW>) {$users_allow .= $textline}
    close (ALLOW);

    open (DENY, "$root/$TREE/$LOCATION/USERS.DENY")
        || &raise_stop_exception("Can't open $root/$TREE/$LOCATION/" . 
                                 "USERS.DENY");
    while ($textline = <DENY>) {$users_deny .= $textline}
    close (DENY);


    # -- print form for new one :

    open (FORM, "$html_lib_dir/admin_add_branch_form.html_src")
        || &raise_stop_exception("Can't open admin_add_branch_form");

    while($textline = <FORM>) {
        $textline =~ s/%usersallow%/$users_allow/;
        $textline =~ s/%usersdeny%/$users_deny/;
        $textline =~ s/%tree%/$TREE/;
        $textline =~ s/%username%/$USERNAME/;
        $textline =~ s/%location%/$LOCATION/;
        print $textline;
      }

    close (FORM);
  }


# -----------------------------------------------------------------------------

sub actually_add_branch() {

  my $TREE      = shift;
  my $LOCATION  = shift;
  my $NEWBRANCH = shift; 
  my $README    = shift; 
  my $ALLOW     = shift;
  my $DENY      = shift;
  my $USERNAME  = shift;

    mkdir ("$root/$TREE/$LOCATION/$NEWBRANCH", 0777)
        || &raise_stop_exception("Can't mkdir: $root/$TREE/$LOCATION/" . 
                                 "$NEWBRANCH");

    open (README, ">$root/$TREE/$LOCATION/$NEWBRANCH/README.node")
        || &raise_integrity_exception("Can't write README: $TREE/$LOCATION/" . 
                                      "$NEWBRANCH/README.node");
    print README $README;
    close (README);

    open (ALLOW, ">$root/$TREE/$LOCATION/$NEWBRANCH/USERS.ALLOW")
        || &raise_integrity_exception("Can't write ALLOW: $TREE/$LOCATION/" .
                                      "$NEWBRANCH/USERS.ALLOW");
    print ALLOW $ALLOW;
    close (ALLOW);

    open (DENY, ">$root/$TREE/$LOCATION/$NEWBRANCH/USERS.DENY")
        || &raise_integrity_exception("Can't write DENY: $TREE/$LOCATION/" .
                                      "$NEWBRANCH/USERS.DENY");
    print DENY $DENY;
    close (DENY);


    # -- Tell'em what we done :

    print "<H1><FONT FACE=\"helvetica\" COLOR=\"\#006800\"><B>Added branch :</B></FONT></H1>";

    print "<TABLE>
             <TR>
               <TD><B>Tree</B></TD>
               <TD><FONT FACE=\"courier\">$TREE</TD>
             </TR><TR>
               <TD><B>Location</B></TD>
               <TD><FONT FACE=\"courier\">$LOCATION</TD>
             </TR><TR>
               <TD><B>New Branch</B></TD>
               <TD><FONT FACE=\"courier\">$NEWBRANCH</TD>
             </TR><TR>
               <TD VALIGN=\"top\"><B>Readme</B></TD>
               <TD><PRE>$README</PRE></TD>
             </TR><TR>
               <TD VALIGN=\"top\"><B>Allow</B></TD>
               <TD><PRE>$ALLOW</PRE></TD>
             </TR><TR>
               <TD VALIGN=\"top\"><B>Deny</B></TD>
               <TD><PRE>$DENY</PRE></TD>
             </TR>
           </TABLE>";

    &refresh_to_admin_menu($TREE, $USERNAME);
  }

# -----------------------------------------------------------------------------

sub actually_delete_branch() {

  my $TREE     = shift;
  my $LOCATION = shift;
  my $USERNAME = shift;

    my $filename;

    # -- check empty first (does it contain a THINGY-file?) :
    opendir(DIR, "$root/$TREE/$LOCATION")
      || &raise_stop_exception("Can't seem to find branch: $TREE/$LOCATION");

    foreach $filename (readdir(DIR)) {
        unless (($filename eq ".") || ($filename eq "..") ||
                ($filename =~ m/^README.node/) || 
                ($filename =~ m/^USERS.ALLOW/) || 
                ($filename =~ m/^USERS.DENY/)) {
            &raise_info_exception("Branch is not empty --- not deleting!");
          }
      }
    closedir(DIR);    

    opendir(DIR, "$root/$TREE/$LOCATION")
      || &raise_stop_exception("Can't seem to find branch: $TREE/$LOCATION");

    # -- delete (the above) files in it :
    foreach $filename (readdir(DIR)) {
        if (($filename =~ m/^README.node/) || 
            ($filename =~ m/^USERS.ALLOW/) || 
            ($filename =~ m/^USERS.DENY/)) {
            unlink "$root/$TREE/$LOCATION/$filename"
                || &raise_integrity_exception("Can't delete: $TREE/" .
                                              "$LOCATION/$filename, " . 
                                              "giving up.");

            print "\n<BR>Deleting <TT>$filename</TT>";
          }
      }

    closedir(DIR);    

    # -- delete directory :
    rmdir "$root/$TREE/$LOCATION"
        || &raise_integrity_exception("Unable to delete: $TREE/$LOCATION");

    print "\n<BR><BR> Deleted: $TREE/$LOCATION";

    &refresh_to_admin_menu($TREE, $USERNAME);
  }


# -----------------------------------------------------------------------------

sub clean_name() {

  my $name = shift @_;

    # -- eliminate spaces :

    $name =~ s/\s/_/gs;

    return $name;
  }

# -----------------------------------------------------------------------------
# -- PRIVATES :


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
