# -----------------------------------------------------------------------------
package admin_change_permissions_cdf;
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# History :
# 
# -- 2001 Feb 26: 
#          
# -- 
# 
# -----------------------------------------------------------------------------

use strict;
use vars qw(@ISA @EXPORT);

use admin_bits;
use config;
use debug;
use exceptions;

use CDF;

# -----------------------------------------------------------------------------

require Exporter;

@ISA = qw(Exporter);
@EXPORT = qw(print_select_cdf_form
             actually_change
             print_change_form
             print_else_message);

# -----------------------------------------------------------------------------
# -- MODULE/PACKAGE VARS :
# -----------------------------------------------------------------------------

my $root         = &root;
my $html_lib_dir = &html_lib_dir;

# -----------------------------------------------------------------------------
# -- EXPORTS :


sub print_else_message () {
    print "<H1>It appears you have called this script oddly, ummm???</H1>";
  }

# -----------------------------------------------------------------------------

sub print_select_cdf_form () {

  my $USERNAME = shift;
  my $TREE     = shift;

    my $textline;

####    print "\n<BR> TREE: $TREE............";

    my $cdf = CDF->new($TREE, "/");
    my $branches = $cdf->rec_childs($TREE, "");
    my $cdf_selector = "<B>Available Branches: </B>";
  
    $cdf_selector = "<SELECT NAME=\"CDF\" SIZE=1>\n";
    foreach (@$branches) {$cdf_selector .= "<OPTION>$_\n";}
    $cdf_selector .= "</SELECT>\n"; 

    open (FORM, "$html_lib_dir/admin_change_permissions_select_cdf_form.html_src")
        || &raise_stop_exception("Can't open " . 
                                 "admin_change_permissions_select_cdf_form");

    while($textline = <FORM>) {
        $textline =~ s/%username%/$USERNAME/;
        $textline =~ s/%tree%/$TREE/;
        $textline =~ s/%cdfselector%/$cdf_selector/;
        print $textline;
      }

    close (FORM);
  }

# -----------------------------------------------------------------------------

sub print_change_form () {

  my $USERNAME = shift;
  my $TREE     = shift;
  my $CDF      = shift;

    my $textline;

    my $cdf = CDF->new($TREE, $CDF);
    my $DENY  = $cdf->deny;
    my $ALLOW = $cdf->allow;


    open (FORM, "$html_lib_dir/admin_change_permissions_cdf_form.html_src")
        || &raise_stop_exception("Can't open " . 
                                 "admin_change_permissions_cdf_form");

    while($textline = <FORM>) {
        $textline =~ s/%cdf%/$CDF/;
        $textline =~ s/%allow%/$ALLOW/;
        $textline =~ s/%deny%/$DENY/;
        $textline =~ s/%cdf%/$CDF/;
        $textline =~ s/%tree%/$TREE/;
        $textline =~ s/%username%/$USERNAME/;
        print $textline;
      }

    close (FORM);
  }

# -----------------------------------------------------------------------------

sub actually_change () {

  my $USERNAME = shift;
  my $TREE     = shift;
  my $BRANCH   = shift;
  my $ALLOW    = shift;
  my $DENY     = shift;

    my $title_refresh = &refresh_to_admin_menu_alt_too($TREE, $USERNAME, 
                         "Changed <TT>$TREE$BRANCH</TT> permissions to:");

    print $title_refresh;

    print "\n<H2>Allow:</H2>";
    print "\n<PRE>$ALLOW</PRE>";
    print "\n<H2>Deny:</H2>";
    print "\n<PRE>$DENY</PRE>";


    # -- move USERS.ALLOW and USERS.DENY to backup files 
    #    (e.g., USERS.ALLOW--3878783, where that is the atime(?)) :

    my ($size, $atime);

    ($size, $atime) 
        = (stat("$root$TREE$BRANCH/USERS.ALLOW")) [7,8];

    rename("$root$TREE$BRANCH/USERS.ALLOW", 
           "$root$TREE$BRANCH/USERS.ALLOW--$atime");

    # -- write new USERS.ALLOW and USERS.DENY :
    open(ALLOW, ">$root$TREE$BRANCH/USERS.ALLOW")
        || &raise_integrity_exception("Can't open (w) " . 
                                      "$root$TREE$BRANCH/USERS.ALLOW");
    print ALLOW $ALLOW;
    close(ALLOW);


    ($size, $atime) 
        = (stat("$root$TREE$BRANCH/USERS.DENY")) [7,8];

    rename("$root$TREE$BRANCH/USERS.DENY", 
           "$root$TREE$BRANCH/USERS.DENY--$atime");

    # -- write new USERS.DENY and USERS.DENY :
    open(DENY, ">$root$TREE$BRANCH/USERS.DENY")
        || &raise_integrity_exception("Can't open (w) " . 
                                      "$root$TREE$BRANCH/USERS.DENY");
    print DENY $DENY;
    close(DENY);

  }

# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------

