# -----------------------------------------------------------------------------
package admin_entries;
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# History :
# 
# -- 2001 Mar 02: 
#          
# -- 
# 
# -----------------------------------------------------------------------------

use strict;
use vars qw(@ISA @EXPORT);

use config;
use debug;
use exceptions;

# -----------------------------------------------------------------------------

require Exporter;

@ISA = qw(Exporter);
@EXPORT = qw(delete_entry);

# -----------------------------------------------------------------------------
# -- MODULE/PACKAGE VARS :
# -----------------------------------------------------------------------------

my $root = &root;


# -----------------------------------------------------------------------------
# -- EXPORTS :

# -- pretend to delete a THINGY file and its associated bits;  move all to
#    a trash-directory really of course :

sub delete_entry () {

  my $TREE = shift;
  my $LOCATION = shift;
  my $ENTRY = shift;

    my $filename;

    # -- check exists :
    unless (-e "$root$TREE$LOCATION$ENTRY" . "--THINGY") {
        &raise_info_exception("Entry: $root$TREE$LOCATION$ENTRY--THINGY, " . 
                              "does not exist!");
      }

    # -- move to trash-dir :
    opendir(DIR, "$root$TREE$LOCATION")
        || &raise_integrity_exception("Can't opendir: $root$TREE$LOCATION");

    foreach $filename (readdir(DIR)) {
        if ($filename =~ m/^$ENTRY\-\-/) {
            rename ("$root$TREE$LOCATION$filename", "$root/trash/$filename") 
                || &raise_integrity_exception("Can't delete file: " .
                                              "$TREE$LOCATION$filename");
          }
      }

    closedir(DIR);

    # -- tell 'em :
    print "Deleted!";
  }


# -----------------------------------------------------------------------------
# -- PRIVATES :



# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
