#!/usr/bin/perl -w -I . -I /home/httpd/cgi-bin/doc_lib_b3/_lib -I /home/httpd/cgi-bin/doc_lib_b3/_sal -I /home/httpd/cgi-bin/doc_lib_b3/_config -I /home/httpd/cgi-bin/doc_lib_b3/_cgi_lib

# -----------------------------------------------------------------------------
use strict;

use CGI;
use CGI::Carp qw(fatalsToBrowser);

use client_bits;
use cookies;
use exceptions;

use admin_tool;

# -----------------------------------------------------------------------------

my ($admin_cookie_key, $admin_cookie_value);
my ($cookie_key, $cookie_value);

# -----------------------------------------------------------------------------
# INIT :

my $query = new CGI;
    # ...get pointer to CGI ENV, then extract stuff :

my $USERNAME = $query->param('USERNAME');
my $REALNAME = $query->param('REALNAME');
my $PASSWORD = $query->param('PASSWORD');
my $LOGIN    = $query->param('LOGIN');
my $NEWBIE   = $query->param('NEWBIE');
my $TREE     = $query->param('TREE');
my $ACTION   = $query->param('ACTION');


# -----------------------------------------------------------------------------
# -- LOGIN PROCESS :

if ($LOGIN =~ m/LOG_ME_IN/) {
    &begin_html("", "Doc-U-Lib Admin-Tool: Login Page");
    &print_simple_header();
    &print_login_form();
    exit;
  }
elsif (&valid_admin_cookie()) {
    &begin_html("", "Doc-U-Lib Admin-Tool: Menu Page");
    my $REALNAME = 
    &print_admin_header($USERNAME, $TREE, $REALNAME);
  }
elsif (($PASSWORD =~ m/\S/) || ($USERNAME =~ m/\S/)) {

    if (&valid_admin_uname_passwd($USERNAME, $PASSWORD)) {

        ($admin_cookie_key, $admin_cookie_value) = &new_admin_cookie();
        ($cookie_key, $cookie_value) = &new_cookie();

        &begin_html("Set-Cookie: $admin_cookie_key=$admin_cookie_value; " . 
                    "path=/; " .
                    "domain=umist.ac.uk" .
                    "\n" .
                    "Set-Cookie: $cookie_key=$cookie_value; " . 
                    "path=/; " .
                    "domain=umist.ac.uk", 
                    "Doc-U-Lib Admin-Tool: Menu Page");
        &print_simple_header();
      }
    else {

        &begin_html("", "Doc-U-Lib Admin-Tool: Login/Menu Page");
        &print_simple_header();
        &raise_logout_exception("dodgy_uname_passwd");
      }
  }
else {
    &begin_html("", "Doc-U-Lib Admin-Tool: Menu Page");
    &print_simple_header();

    &raise_logout_exception("invalid_cookie");
  }

# -----------------------------------------------------------------------------
# -- YUR-INE :


if ($ACTION eq 'REVIEW_PASSWD_DIR') {
    &review_passwd_dir($query, $TREE, $USERNAME);
  }
elsif ($ACTION eq 'REVIEW_INDIV_USER_ACCESS_CONTROL') {
    &review_indiv_user_access_control($query, $TREE, $USERNAME);
  }
else {
    &print_admin_menu($TREE, $USERNAME);
  }


# -----------------------------------------------------------------------------
# -- TEA-TIME :

&print_std_footer;
&end_html;

# -----------------------------------------------------------------------------

