# -----------------------------------------------------------------------------
package move_entry;
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# History :
# 
# -- 2001 Feb 28: 
#          
# -- 
# 
# -----------------------------------------------------------------------------

use strict;
use vars qw(@ISA @EXPORT);

use config;
use debug;

use up_mod;

use CDF;

# -----------------------------------------------------------------------------

require Exporter;

@ISA = qw(Exporter);

@EXPORT = qw(print_select_new_locat_form
             actually_move_entry);

# -----------------------------------------------------------------------------
# -- MODULE/PACKAGE VARS :
# -----------------------------------------------------------------------------

my $root = &root;


# -----------------------------------------------------------------------------
# -- EXPORTS :

sub print_select_new_locat_form() {

  my $except   = shift;

  my $TREE     = shift;
  my $LOCATION = shift;
  my $USERNAME = shift;
  my $REALNAME = shift;
  my $THINGY   = shift;

    my $textline;
    my $cdf = CDF->new($TREE, "/");
    my $branches = $cdf->rec_childs($TREE, "");
    my $branch_selector = "<B>Available Branches: </B>";

    $branch_selector = "<SELECT NAME=\"NEWLOCAT\" SIZE=1>\n";
    foreach (@$branches) {$branch_selector .= "<OPTION>$_\n";}
    $branch_selector .= "</SELECT>\n"; 

    
    open (FORM, "HTML_LIB/move_entry_form.html_src")
        || $except->raise_stop("Can't open move_entry_form");

    while($textline = <FORM>) {
        $textline =~ s/%branchselector%/$branch_selector/;
        $textline =~ s/%tree%/$TREE/;
        $textline =~ s/%location%/$LOCATION/;
        $textline =~ s/%username%/$USERNAME/;
        $textline =~ s/%realname%/$REALNAME/;
        $textline =~ s/%thingy%/$THINGY/;
        print $textline;
      }

    close (FORM);
  }

# -----------------------------------------------------------------------------

sub actually_move_entry() {

  my $except   = shift;

  my $TREE     = shift;
  my $LOCATION = shift;
  my $USERNAME = shift;
  my $REALNAME = shift;
  my $THINGY   = shift;
  my $NEWLOCAT = shift;

    my $filename;

    opendir(DIR, "$root/$TREE/$LOCATION")
        || $except->raise_integrity("Can't open $TREE/$LOCATION");

    foreach $filename (readdir(DIR)) {
        if ($filename =~ m/^$THINGY/) {
            print "\n<BR>moving: $filename";
            rename("$root/$TREE/$LOCATION/$filename", 
                   "$root/$TREE/$NEWLOCAT/$filename")
                || $except->raise_integrity("Can't move file: $filename");
          }
      }
    closedir(DIR);

    &print_refresh_to_navigate($TREE, "$LOCATION", $USERNAME, $REALNAME);
  }


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
