# -----------------------------------------------------------------------------
package Debug;
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# History :
# 
# -- 2002 Jan 15: first version to make a fresh start over debug.pm;
#          
# -----------------------------------------------------------------------------

use strict;
use config;

# -----------------------------------------------------------------------------

my $level = &debug_level();

# -----------------------------------------------------------------------------
# -- The new debug bit for this (Doc) object/instance : 

sub new() {
    my $class   = shift;
    my $level   = shift;
    my $comment = shift;

    my $self = { };

    bless($self, $class);

    $self->{LEV} = $level;
    $self->{STR} = "\n<TABLE CELLSPACING=0 CELLPADDING=0>";

    my $i = 0;
    while (my @caller = caller($i)) {
        $self->{STR} .= "<TR><TD><FONT FACE=\"courier\">" 
                     . "<B>DEBUG: $caller[1]::$caller[3]</B> ";
        if (my @temp = caller($i + 1)) {
            $self->{STR} .= "called from";
          }
        $self->{STR} .= "</FONT></TD></TR>";
        $i = $i + 1;
      }

    $self->{STR} .= "</TABLE>";

    $self->{STR} .= "\n<TABLE CELLSPACING=0 CELLPADDING=0>" 
                 .  "<TR><TD WIDTH=15></TD><TD>" 
                 .  "<FONT FACE=\"courier\"><I>$comment</I></FONT>" 
                 .  "</TD></TR></TABLE>";

    $self->{STR} =~ s///g;

    return $self;
  }


# -----------------------------------------------------------------------------
# -- item :

sub item () {
    my $self   = shift;
    my $string = shift @_;

    $self->{STR} .= "\n<TABLE CELLSPACING=0 CELLPADDING=0><TR>" 
                 . "<TD WIDTH=30></TD><TD>" 
                 .  "<FONT FACE=courier>$string</FONT>"
                 .  "</TD></TR></TABLE>";
  } 


# -----------------------------------------------------------------------------
# --

sub wen() {
    my $self = shift;
    my $doc  = shift;

    $self->{STR} .= "\n<TABLE CELLSPACING=0 CELLPADDING=0>"
                 .  "<TR><TD WIDTH=0></TD><TD>" 
                 .  "<FONT FACE=courier><B>END DEBUG</B></FONT>"
                 .  "</TD></TR></TABLE>";    

    if ($self->{LEV} <= $level) {
        $doc->{DOCBODY} .= $self->{STR} . "\n<BR>\n";
      }

    $self->{STR} = "";    
  }


# -----------------------------------------------------------------------------
# -- header :

sub head () {
    my $self    = shift;
    my $comment = shift @_;

    $self->{STR} .= "\n<BR><TABLE CELLSPACING=0 CELLPADDING=0>" 
                 .  "<TR><TD WIDTH=15></TD><TD>" 
                 .  "<FONT FACE=\"courier\"><I>$comment</I></FONT>" 
                 .  "</TD></TR></TABLE>";
  } 


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
