# -----------------------------------------------------------------------------
package debug;
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# History :
# 
# -- 2000 Sep 27:  first version;
#          
# -- 2001 Nov 09:  added stuff to make it work with Doc.pm...
# 
# -----------------------------------------------------------------------------

use strict;
use config;
use vars qw(@ISA @EXPORT);

# -----------------------------------------------------------------------------

require Exporter;

# -----------------------------------------------------------------------------

@ISA    = qw(Exporter);
@EXPORT = qw(new_debug debug_flush debug_a debug_h 
             debug_i debug_i debug_s);


# -----------------------------------------------------------------------------


my $level = &debug_level();


# -----------------------------------------------------------------------------
# -- The new debug bit for this (Doc) object/instance : 

sub new_debug() {
    my $self  = shift;
    my $level = shift;
    my $title = shift;

    my $debug = {};

    $debug->{LEV} = $level;

    $debug->{STR} = "\n<TABLE CELLSPACING=0 CELLPADDING=0>" 
                  . "<TR><TD><FONT FACE=\"courier\">" 
                  . "<B>DEBUG: $title</B></FONT></TD></TR></TABLE>";
  }


# -----------------------------------------------------------------------------
# --

sub debug_flush() {
    my $self = shift;

    $self->{DEBUG} .= "\n<TABLE CELLSPACING=0 CELLPADDING=0>"
                   .  "<TR><TD WIDTH=10></TD><TD>" 
                   .  "<FONT FACE=courier><B>:DEBUG</B></FONT>"
                   .  "</TD></TR></TABLE>";    

    if ($debug) {
        $self->{DOCBODY} .= $self->{DEBUG} . "\n<BR>\n";
      }

    $self->{DEBUG}     = "";    
  }


# -----------------------------------------------------------------------------
# -- string/special :

sub debug_s() {
    my $self = shift;
    my $string = shift @_;
    $self->{DEBUG} .= "\n<FONT FACE=\"courier\">$string</FONT>";
  } 


# -----------------------------------------------------------------------------
# -- header :

sub debug_h () {
    my $self   = shift;
    my $string = shift @_;

    my @caller = caller(1);

    $self->{DEBUG} .= "\n<P><B><FONT FACE=\"courier\">" . $caller[3] 
                   .  " :  $string</FONT></B>";
  } 


# -----------------------------------------------------------------------------
# -- item :

sub debug_i () {
    my $self   = shift;
    my $string = shift @_;

    $self->{DEBUG} .= "\n<TABLE CELLSPACING=0 CELLPADDING=0><TR><TD WIDTH=20></TD><TD>" 
                   .  "<FONT FACE=courier>$string</FONT>"
                   .  "</TD></TR></TABLE>";
  } 


# -----------------------------------------------------------------------------
# -- action :

sub debug_a () {
    my $self   = shift;
    my $string = shift @_;

    $self->{DEBUG} .= "...$string...<BR>";
  } 


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
