# -----------------------------------------------------------------------------
package State;
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# History :
# 
# -- 2002 Jan 14: started
# 
# -----------------------------------------------------------------------------

use strict;
use vars qw(@ISA @EXPORT);

use CGI;
use CGI::Carp qw(fatalsToBrowser);

# -----------------------------------------------------------------------------

use config;
use log;

# -----------------------------------------------------------------------------
# -- DOCUMENTATION :
#    
#    
#    
#    
# -----------------------------------------------------------------------------


sub new() {

    my $class   = shift;
    my $cookies = shift;
    my $doc     = shift;
    my $except  = shift;
    my $self    = { };

    bless($self, $class);

    my $query = new CGI;
        # ...pointer to CGI ENV;

    $self->{__COOKIES__} = $cookies;
    $self->{__DOC__}     = $doc;
    $self->{__EXCEPT__}  = $except;

    # -- general stuff :

    $self->{_LOCATION_}    = $query->param('LOCATION');
    $self->{_REALNAME_}    = $query->param('REALNAME');
    $self->{_TREE_}        = $query->param('TREE');
    $self->{_USERNAME_}    = $query->param('USERNAME');

    # -- navigator stuff :

    $self->{_NAVIGATE_}    = $query->param('NAVIGATE');
    $self->{_VIEW_}        = $query->param('VIEW');
    $self->{_VIEWTREEBY_}  = $query->param('VIEWTREEBY');
    $self->{_VIEWONEONLY_} = $query->param('VIEWONEONLY'); 

    # -- upload stuff :

    $self->{_ACTION_}      = $query->param('ACTION');
    $self->{_AUTHOR_}      = $query->param('AUTHOR');
    $self->{_BUTTON_}      = $query->param('BUTTON');
    $self->{_DATEWRITTEN_} = $query->param('DATEWRITTEN');

    # -- upload stuff :

    $self->{_UP_FILE_DEF_}  = $query->param('FILE_DEF');
    $self->{_UP_FILE_VIEW_} = $query->param('FILE_VIEW');
    $self->{_KEYWORDS_}     = $query->param('KEYWORDS');
    $self->{_README_}       = $query->param('README');
    $self->{_HISTORYAPPEND_} = $query->param('HISTORYAPPEND');
    $self->{_DOCNAMEROOT_}   = $query->param('THINGY');


    $self->{_FILE_}   = $query->param('FILE');
    $self->{_THINGY_} = $query->param('THINGY');

    return $self;
  }

# -----------------------------------------------------------------------------
# -- METHODS :
# -----------------------------------------------------------------------------

sub def() {
    my $self      = shift;
    my $attribute = shift;

    if (defined $self->{"_" . $attribute . "_"}) { return 1; }
    else                                         { return 0; }
  }


# -- attr is for attribute :

sub attr() {
    my $self      = shift;
    my $attribute = shift;

    if (defined $self->{"_" . $attribute . "_"}) {
        return $self->{"_" . $attribute . "_"};
      }
    else {
        $self->{__EXCEPT__}->raise_logout_2($self->{__COOKIES__},
                                            $self->{__DOC__},
                                            $self,
                                           "Missing attribute: " . $attribute);
      }
  }
 

# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
