# -----------------------------------------------------------------------------
package log;
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# History :
# 
# -- 2001 Jan 10: 
#          
# -- 
# 
# -----------------------------------------------------------------------------

use strict;
use vars qw(@ISA @EXPORT);

# -----------------------------------------------------------------------------

require Exporter;

# -----------------------------------------------------------------------------

use config;

# -----------------------------------------------------------------------------

@ISA    = qw(Exporter);
@EXPORT = qw(log_login log_read 
             log_upload_new_doc 
             log_upload_new_ver
             log_exception_2
             log_exception);

# -----------------------------------------------------------------------------
my $log_dir = &log_dir;
# -----------------------------------------------------------------------------

# There are various log files :
 
my $log_log_file    = "login.log";
my $read_log_file   = "read.log";
my $upload_log_file = "upload.log";
my $exception_log_file = "exception.log";

# -----------------------------------------------------------------------------

# --

sub log_login () {

  my $username = shift;

    if (-e $log_dir . "/" . $log_log_file) {
        open(LLOG, ">>$log_dir/$log_log_file");
      }
    else {
        open(LLOG, ">$log_dir/$log_log_file");
      }

    print LLOG $username . " : " . time() . "\n";
    close(LLOG);
  }

# -----------------------------------------------------------------------------
# --

sub log_exception_2 () {

  my $caller = shift;
  my $u      = shift;
  my $t      = shift;
  my $l      = shift;
  my $string = shift;

    if (-e $log_dir . "/" . $exception_log_file) {
        open(ELOG, ">>$log_dir/$exception_log_file");
      }
    else {
        open(ELOG, ">$log_dir/$exception_log_file");
      }

    my ($sec, $min, $hour, $day, $month, $year) = (localtime)[0,1,2,3,4,5];

    $month += 1;
    $year  += 1900;

    if (length $month == 1) {$month = "0$month"}
    if (length $min == 1) {$min = "0$min"}
    if (length $sec == 1) {$sec = "0$sec"}

    print ELOG "\n $year/$month/$day $hour:$min:$sec";
    print ELOG "\n     $caller ";
    print ELOG "\n     $u, $t, $l ";
    print ELOG "\n         $string";
    print ELOG "\n";

    close(ELOG);
  }

# -----------------------------------------------------------------------------
# --

sub log_exception () {

  my $string = shift;

    if (-e $log_dir . "/" . $exception_log_file) {
        open(ELOG, ">>$log_dir/$exception_log_file");
      }
    else {
        open(ELOG, ">$log_dir/$exception_log_file");
      }

    print ELOG time() . " $string\n";
    close(ELOG);
  }

# -----------------------------------------------------------------------------
# --

sub log_read () {

  my $username = shift;

    if (-e $log_dir . "/" . $read_log_file) {
        open(RLOG, ">>$log_dir/$read_log_file");
      }
    else {
        open(RLOG, ">$log_dir/$read_log_file");
      }

    print RLOG $username . " : " . time() . "\n";
    close(RLOG);
  }

# -----------------------------------------------------------------------------
# --

sub log_upload_new_doc () {

  my $username = shift;
  my $def      = shift;
  my $view     = shift;

    if (-e $log_dir . "/" . $upload_log_file) {
        open(DLOG, ">>$log_dir/$upload_log_file");
      }
    else {
        open(DLOG, ">$log_dir/$upload_log_file");
      }

    print DLOG "$username, new (def, view) : $def, $view " . time() . "\n";
    close(DLOG);
  }

# -----------------------------------------------------------------------------
# --

sub log_upload_new_ver () {
 
  my $username = shift;
  my $def      = shift;
  my $view     = shift;

    if (-e $log_dir . "/" . $upload_log_file) {
        open(VLOG, ">>$log_dir/$upload_log_file");
      }
    else {
        open(VLOG, ">$log_dir/$upload_log_file");
      }

    print VLOG "$username, version (def, view) : $def, $view " . time() . "\n";
    close(VLOG);
 }


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
