# -----------------------------------------------------------------------------
package history;
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# History :
# 
# -- 20021 Jan 19:  written from history.pl so as to meld history.pl into
#                   navigate.pl
# 
# -----------------------------------------------------------------------------

use strict;
use vars qw(@ISA @EXPORT);

# -----------------------------------------------------------------------------

require Exporter;

# -----------------------------------------------------------------------------

use config;
use date_time;

# -----------------------------------------------------------------------------
# -- PUBLIC INTERFACE :

@ISA    = qw(Exporter);
@EXPORT = qw(print_history);

# -----------------------------------------------------------------------------
# -- MODULE/PACKAGE VARS :

my $cgi_root_dir = &cgi_root_dir;
my $root         = &root;


# -----------------------------------------------------------------------------
# -- EXPORT :
# -----------------------------------------------------------------------------


sub print_history() {

  my $doc = shift;
  my $s   = shift;
  my $thingy = shift;

    my @history = split(/\n/, $thingy->history);
    my $history = "";

    foreach (@history) {
        if ($_ =~ m/<DATE>\d*<\/DATE>/) {
            $_ =~ s/.*<DATE>(\d*)<\/DATE>.*/$1/;
            $_ = &date_time($_);
            $_ = "<DATE>$_</DATE>\n";
          }

        if ($_ =~ m/<DATEWRIT>\d*<\/DATEWRIT>/) {
            $_ =~ s/.*<DATEWRIT>(\d*)<\/DATEWRIT>.*/$1/;
            $_ = &date_time($_);
            $_ = "<DATEWRIT>$_</DATEWRIT>\n";
          }

        $history .= $_;
      }

    $doc->append("\n<HR>");
    $doc->append("\n<H1>History: " . 
                 $s->attr("TREE") . $s->attr("LOCATION") . 
                 $thingy->{NAME} . "</H1>");

    $history =~ s/<HISTORY>//gs;
    $history =~ s/<\/HISTORY>/<BR><BR>/gs;

    $history =~ s/<DATE>/<BR><B>Uploaded: <\/B>/gs;
    $history =~ s/<\/DATE>//gs;

    $history =~ s/<DEFINITIVE>/<BR><B>Definitive: <\/B>/gs;
    $history =~ s/<\/DEFINITIVE>//gs;

    $history =~ s/<VIEWONLY>/<BR><B>Viewonly: <\/B>/gs;
    $history =~ s/<\/VIEWONLY>//gs;

    $history =~ s/<KEYWORDS>/<BR><B>Keywords: <\/B>/gs;
    $history =~ s/<\/KEYWORDS>//gs;

    $history =~ s/<AUTHOR>/<BR><B>Author: <\/B>/gs;
    $history =~ s/<\/AUTHOR>//gs;

    $history =~ s/<DATEWRIT>/<BR><B>Written: <\/B>/gs;
    $history =~ s/<\/DATEWRIT>//gs;

    $history =~ s/<UPLOADER>/<BR><B>Uploader: <\/B>/gs;
    $history =~ s/<\/UPLOADER>//gs;

    $history =~ s/<README>/<BR><B>Readme: <\/B>/gs;
    $history =~ s/<\/README>//gs;


    # -- do some substitutions to make history entries into qs-links :

    my $qslink_1 = "<A HREF=\"" . $cgi_root_dir . "query_string.mime.pl\?" 
                 . "FILE\=$root" . $s->attr("TREE") 
                 . $s->attr("LOCATION") . "/";

    my $qslink_2 = "\&LOCATION=" . $s->attr("LOCATION") . "\&TREE=" 
                 . $s->attr("TREE") . "\&USERNAME=" . $s->attr("USERNAME");

    $history =~ s/<QSLINK>([0-9a-zA-Z_\-\.\s\~]*)<\/QSLINK>/$qslink_1$1$qslink_2\">$1<\/A>/gs;

    return $history;
  }


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
