# -----------------------------------------------------------------------------
package nav_mod;
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# History :
# 
# -- 2000 Nov 28: 
#          
# -- 2001 Oct 29: 1.0 done, hurrah!
# 
# -----------------------------------------------------------------------------

use strict;
use vars qw(@ISA @EXPORT);

# -----------------------------------------------------------------------------

require Exporter;

# -----------------------------------------------------------------------------

use config;
use date_time;

use Thingy;

# -----------------------------------------------------------------------------
# -- PUBLIC INTERFACE :

@ISA    = qw(Exporter);
@EXPORT = qw(cdf_readme_and_links_table
             nav_thingy);

# -----------------------------------------------------------------------------
# -- MODULE/PACKAGE VARS :

my $cgi_root_dir = &cgi_root_dir;
my $tree         = &tree;
my $root         = &root;


# -----------------------------------------------------------------------------
# -- EXPORT :
# -----------------------------------------------------------------------------

# -- print a table in which we find:  the CDF readme, links to its children,
#    and links to the search and upload-new-document pages :

sub cdf_readme_and_links_table() {

  my $readme = shift;
  my $childs = shift;
  my $s      = shift;

    my $USERNAME = $s->attr("USERNAME");
    my $REALNAME = $s->attr("REALNAME");
    my $TREE     = $s->attr("TREE");    
    my $LOCATION = $s->attr("LOCATION");

    my $string = "";

# -- SPECIAL :: 
    $string .= "<TABLE WIDTH=\"100%\" BORDER=0><TR>\n";
    $string .= "<TD WIDTH=\"45%\" VALIGN=\"top\">\n";
    $string .= "<B>Readme:</B><BR><BR>\n";
    $string .= "$readme \n";
    $string .= "<BR><BR>\n";
#    $string .= "<B>Branches:</B>\n";
#    $string .= "<TT>\n";
#    $string .= "<UL>\n";
#    if (scalar(@$childs) == 0) {$string .= "None."}
#    foreach (sort {lc($a) cmp lc($b)} @$childs) {
#        $string .= "<LI><A HREF=\"" . $cgi_root_dir . "navigate.pl\?" 
#                               . "NAVIGATE\=NAVIGATE\&" 
#                               . "LOCATION\=$LOCATION$_/\&" 
#                               . "TREE\=$TREE\&"
#                               . "USERNAME\=$USERNAME\&"
#                               . "REALNAME\=$REALNAME\&"
#                               . "VIEW\=" . &default_view
#                               . "\">" . $_ . "</A>\n";
#      }
#    $string .= "</UL>\n";
#    $string .= "</TT>\n";
    $string .= "</TD>\n";
    $string .= "<TD WIDTH=\"10%\"></TD>\n";
    $string .= "<TD VALIGN=\"top\">\n";
# -- SPECIAL
    if (($USERNAME eq "mpciish2") || ($USERNAME eq "mpciime")) {
        $string .= &search_upload_links($TREE, $LOCATION, 
                                        $USERNAME, $REALNAME);
      }
# -- :: SPECIAL
    $string .= "</TD>\n";
    $string .= "</TR></TABLE>\n";
# -- :: SPECIAL

    return $string;
  }


# -----------------------------------------------------------------------------
# -- print to stdout the attributes of an Entry together with links to 
#    the documents themselves :

sub nav_thingy() {

  my $cookies   = shift;
  my $doc       = shift;
  my $except    = shift;
  my $s         = shift @_;
  my $thingy    = shift @_;

    my $string = "";

    my $USERNAME  = $s->attr("USERNAME");
    my $REALNAME  = $s->attr("REALNAME");
    my $TREE      = $s->attr("TREE");
    my $LOCATION  = $s->attr("LOCATION");

    my $thingy_name = $thingy->name;
    my $keywords    = $thingy->keywords;
    my $author      = $thingy->author;
    my $uploader    = $thingy->uploader;
    my $readme      = $thingy->readme;
    my $up_time     = $thingy->time;
    my $date_writ   = $thingy->datewrit;
    my $def_file    = $thingy->definitive;
    my $view_file   = $thingy->viewonly;

    # -- cgi doesn't like things with spaces in ...

    $thingy_name =~s/([^a-zA-Z0-9_.-])/uc sprintf("%%%02x",ord($1))/eg;
            # ...hex-encode urls (e.g., for characters such as '&')
            #    see the 'escape' and 'unescape' routines in CGI.pm
            #    also p76: URL encoding, of Webmaster in a Nutshell.
            #    for completeness, note:
            #        $thingy_name =~ s/%([0-9a-fA-F]{2})/pack("c",hex($1))/ge;
            #    decodes...

    $up_time   = &date_time($up_time);
    $date_writ = &date_time($date_writ);

    $string .= "<TABLE BORDER=0 CELLSPACING=1 CELLPADDING=0><TR>\n";

    # -- definitive : ---------------------------------------------------------

# -- SPECIAL :: 
    $string .= "<TD></TD>";
# -- :: SPECIAL

    if (@$def_file[0] eq "none") {
# -- SPECIAL :: 
        $string .= "<TD WIDTH=\"4%\"></TD><TD></TD>\n";
# -- :: SPECIAL
      }
    else {
        $string .=
              "<TD WIDTH=\"2%\"><B> : </B></TD><TD>" . " " 
            . "<A HREF=\"" . $cgi_root_dir . "query_string.mime.pl\?" 
            . "FILE\=$root$TREE$LOCATION/" . $thingy_name 
                                           . "--" . @$def_file[0] . "\&"
            . "LOCATION\=$LOCATION\&" 
            . "TREE\=$TREE\&"
        .     "REALNAME\=$REALNAME\&" 
            . "USERNAME\=$USERNAME"  
            . "\">" 
            . @$def_file[0] . "</A>"
# -- SPECIAL :: 
            . " (size: @$def_file[1]"
# -- :: SPECIAL
            . ") </TD>\n";
      }

    $string .= "</TR><TR>\n";


    # -- view-only : ----------------------------------------------------------

# -- SPECIAL :: 
    $string .= "<TD><B><SMALL>DOWNLOAD</SMALL></B></TD>";
# -- :: SPECIAL

    if (@$view_file[0] eq "none") {
        $string .= "<TD><B>:</B></TD><TD> none</TD>\n";
      }
    else {
        $string .= 
              "<TD><B>:</B></TD><TD>" . " "
# -- SPECIAL ::
#           . "<A HREF=\"" . $cgi_root_dir . "query_string.mime.pl\?" 
# -- :: SPECIAL  
            . "<A HREF=\"" . $cgi_root_dir . "/var/Respondus204Campus.exe\?"
##          . "<A HREF=\"" . $cgi_root_dir . "webct_download.file\?" 
            . "FILE\=$root$TREE$LOCATION/" . $thingy_name 
                                           . "--" . @$view_file[0] . "\&"
            . "LOCATION\=$LOCATION\&" 
            . "TREE\=$TREE\&"
            . "USERNAME\=$USERNAME"  
            . "\">" 
            . @$view_file[0] . "</A>" 
# -- SPECIAL :: 
            . " (size: @$view_file[1]" 
# -- :: SPECIAL
            . ")</TD>\n";
      }

    $string .= "</TR>\n";

    my $keywords_str = "";
    foreach (@$keywords) {$keywords_str .= $_ . " "}

# -- SPECIAL :: 
#    $string .= &put_bit_row("AUTHOR", $author);
#    $string .= &put_bit_row("WRITTEN", $date_writ);
# -- :: SPECIAL
    $string .= &put_bit_row("UPLOAD DATE", $up_time);
    $string .= &put_bit_row("README", $readme);
    $string .= &put_bit_row("KEYWORDS", $keywords_str);

    $string .= "<BR></TD></TR><TR>\n";


    # -- links to history, new version and move entry : -----------------------

# -- SPECIAL :: 
     $string .= "<TD COLSPAN=3>";
#    $string .= "<TD COLSPAN=3><A HREF=\"" . $cgi_root_dir 
#        . "navigate.pl\?" 
#        .     "NAVIGATE\=HISTORY\&"
#        .     "TREE\=$TREE\&LOCATION\=$LOCATION\&" 
#        .     "USERNAME\=$USERNAME\&REALNAME\=$REALNAME\&" 
#        .     "THINGY\=$thingy_name"
#        . "\">get history</A>\n";
#
#    $string .= "<FONT FACE=\"courier\"><BIG>|</BIG></FONT>\n";
#
#    $string .= "<A HREF=\"" 
#        .     $cgi_root_dir . "upload.pl\?ACTION=FORM_NEW_VERSION\&" 
#        .     "TREE\=$TREE\&LOCATION\=$LOCATION\&" 
#        .     "USERNAME\=$USERNAME\&REALNAME\=$REALNAME\&" 
#        .     "THINGY\=$thingy_name"
#        .     "\">new version</A>\n";
#
#
#    if ($cookies->valid_admin_cookie($doc, $except)) {
#        $string .= "<FONT FACE=\"courier\"><BIG>|</BIG></FONT>\n";
#
#      $string .= "<A HREF=\"" 
#          .     $cgi_root_dir . "move_entry.pl\?" 
#          .     "SELECTNEWLOCAT=selnewlocat\&" 
#          .     "TREE\=$TREE\&LOCATION\=$LOCATION\&" 
#          .     "USERNAME\=$USERNAME\&REALNAME\=$REALNAME\&" 
#          .     "THINGY\=$thingy_name"
#          .     "\">move_entry</A>\n</TD>\n";
#      }

    $string .= "</TD>";
# -- :: SPECIAL

    $string .= "</TD></TR></TABLE>\n";
    $string .= "<BR>\n";

    return $string;
  }


# -----------------------------------------------------------------------------
# -- PRIVATE :
# -----------------------------------------------------------------------------

# -- links to search pages and links to upload pages :

sub search_upload_links() {

  my $TREE     = shift @_;
  my $LOCATION = shift @_;
  my $USERNAME = shift @_;
  my $REALNAME = shift @_;
 
    my $string = "";

# -- SPECIAL :: 

    $string .= "\n<TABLE WIDTH=\"100%\" BGCOLOR=\"white\" " 
        . "BORDER=0 CELLSPACING=0 CELLPADDING=8><TR>";
#    $string .= "\n<TD WIDTH=\"50%\" BGCOLOR=\"\#EEEEEE\" VALIGN=\"top\">" .
#          "View all entries in current tree:</TD>";
#    $string .= "\n<TD WIDTH=\"50%\" BGCOLOR=\"\#EEEEEE\"><UL>";
#    $string .= "\n<LI>by <A HREF=\"navigate.pl?" . 
#          "NAVIGATE=VIEWTREE". 
#          "\&TREE=$TREE\&LOCATION\=$LOCATION". 
#          "\&USERNAME\=$USERNAME\&REALNAME\=$REALNAME" . 
#          "\&VIEWTREEBY=structure\">structure</A>";
#    $string .= "\n<LI>by <A HREF=\"navigate.pl?" . 
#          "NAVIGATE=VIEWTREE". 
#          "\&TREE=$TREE\&LOCATION\=$LOCATION". 
#          "\&USERNAME\=$USERNAME\&REALNAME\=$REALNAME" . 
#          "\&VIEWTREEBY=revcron\">rev chron</A></TD>";
#    $string .= "\n</TR><TR>";
    $string .= "\n<TD BGCOLOR=\"\#EEEEEE\" VALIGN=\"top\">"
        . "Upload to this location:</TD>" 
        . "\n<TD BGCOLOR=\"\#EEEEEE\" VALIGN=\"top\">\n";
    $string .= "\n<UL>\n";
    $string .= "\n<LI><A HREF=\"" 
        . $cgi_root_dir . "upload.pl\?ACTION=FORM_NEW_DOC\&" 
        . "TREE\=$TREE\&LOCATION\=$LOCATION\&USERNAME\=$USERNAME\&" 
        . "REALNAME\=$REALNAME" 
        . "\">new document</A>\n";
#    $string .= "\n</UL></TD></TR><TR><TD BGCOLOR=\"\#EEEEEE\" VALIGN=\"top\">";
#    $string .= "View this branch:</TD>";
#    $string .= "\n<TD BGCOLOR=\"\#EEEEEE\" VALIGN=\"top\"><UL>";
#    $string .= "\n<LI>by <A HREF=\"" . $cgi_root_dir . "navigate.pl\?"
#        . "NAVIGATE=NAVIGATE\&" 
#        . "VIEW\=REVCHRON\&" 
#        . "TREE\=$TREE\&LOCATION\=$LOCATION\&USERNAME\=$USERNAME\&" 
#        . "REALNAME\=$REALNAME"
#        . "\">rev chron</A>";
#    $string .= "\n<LI>by <A HREF=\"" . $cgi_root_dir . "navigate.pl\?"
#        . "NAVIGATE=NAVIGATE\&"
#        . "VIEW\=ALPHANUM\&" 
#        . "TREE\=$TREE\&LOCATION\=$LOCATION\&USERNAME\=$USERNAME\&" 
#        . "REALNAME\=$REALNAME"
#        . "\">alphabetical</A>";
#    $string .= "\n</UL></TD></TR><TR><TD BGCOLOR=\"\#EEEEEE\" VALIGN=\"top\">";
#    $string .= "Search this tree:</TD>";
#    $string .= "\n<TD BGCOLOR=\"\#EEEEEE\" VALIGN=\"top\"><UL>";
#    $string .= "\n<LI><A HREF=\"" . $cgi_root_dir . "search.pl\?"
#        . "ACTION\=SEARCH_FORM\&" 
#        . "TREE\=$TREE\&LOCATION\=$LOCATION\&USERNAME\=$USERNAME\&" 
#        . "REALNAME\=$REALNAME"
#        . "\">search</A>";
    $string .= "\n</UL></TD></TR></TABLE>\n";
    $string .= "\n</UL>\n";   

# -- :: SPECIAL 

    return $string;
  }


# -----------------------------------------------------------------------------


sub put_bit_row() {

  my $text  = shift;
  my $value = shift;

    my $string = "";

    $string .= "<TR>";
    $string .= "<TD><B><SMALL>$text</SMALL></B></TD>" 
            . "<TD><B>:</B></TD><TD>$value</TD>\n";
    $string .= "</TR>\n";

    return $string;
  }


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
