# -----------------------------------------------------------------------------
package sea_mod_form;
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# History :
# 
# -- 2001 Jul 02: 
#          
# -- 
# 
# -----------------------------------------------------------------------------

use strict;
use vars qw(@ISA @EXPORT);

# -----------------------------------------------------------------------------

require Exporter;

# -----------------------------------------------------------------------------

use config;

my $cgi_root_dir = &cgi_root_dir();

# -----------------------------------------------------------------------------

@ISA    = qw(Exporter);
@EXPORT = qw(search_form);

# -----------------------------------------------------------------------------
# -- FORM :
# -----------------------------------------------------------------------------

sub search_form() {

  my $except = shift;
  my $query  = shift;

  my $USERNAME = shift;
  my $REALNAME = shift;
  my $TREE     = shift;
  my $LOCATION = shift;

  my $TYPE     = shift;

    my $string = "";

    # -- Get tree info we need for the form :
    my $tree     = Tree->new($except, $TREE);
    my $authors  = $tree->{AUTHORS};
    my $keywords = $tree->{KEYWORDS};

    $string .= &form_title();

    if ($TYPE eq "PRINT_FORM") {
        $string .= "\n<TABLE BORDER=0><TR>";
        $string .= "\n<TD VALIGN=top>";
        $string .= "\n<B>Search:</B>";
        $string .= &search_menu($TREE, $REALNAME, $USERNAME);
        $string .= "\n</TD><TD VALIGN=top>";
        $string .= &form_intro_words($query);
        $string .= "\n</TD>";
        $string .= "\n</TR></TABLE>";
      }
    else {
        $string .= "\n<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=10>";
        $string .= "\n";
        $string .= $query->startform("POST", "search.pl", &CGI::MULTIPART);

        if ($TYPE eq "AD_CONSTRAINTS_ONLY") {
            $string .= &author_and_date_constraints_rows($except, $query, 
                                                         $TREE, "with");
          }
        elsif ($TYPE eq "KEYWORD_SEARCH") {
            $string .= &keywords_rows($except, $query, $TREE);
            $string .= &author_and_date_constraints_rows($except, $query, 
                                                         $TREE, "without");
          }
        elsif ($TYPE eq "GREP_ENTRY_NAMES") {
            $string .= &grep_entry_names_rows($query);        
            $string .= &author_and_date_constraints_rows($except, $query, 
                                                         $TREE, "without");
          }
        elsif ($TYPE eq "GREP_FILE_NAMES") {
            $string .= &grep_filenames_rows($query);        
            $string .= &author_and_date_constraints_rows($except, $query, 
                                                         $TREE, "without");
          }
        elsif ($TYPE eq "SWISH_BRANCH_READMES") {
            # -- no author/date constraints for this one...
            $string .= &swish_branch_readmes_rows($query);
          }
        elsif ($TYPE eq "SWISH_ENTRY_READMES") {
            $string .= &swish_entry_readmes_rows($query);
            $string .= &author_and_date_constraints_rows($except, $query, 
                                                         $TREE, "without");
          }
        elsif ($TYPE eq "FILEBODY_SEARCH") {
            $string .= &file_body_search_rows($query);
            $string .= &author_and_date_constraints_rows($except, $query, 
                                                         $TREE, "without");
          }

        $string .= $query->hidden('LOCATION', $LOCATION);
        $string .= $query->hidden('TREE', $TREE);
        $string .= $query->hidden('USERNAME', $USERNAME);
        $string .= $query->hidden('REALNAME', $REALNAME);
        $string .= $query->endform;
        $string .= "\n</TABLE>";
      }

    return $string;
  }


# -----------------------------------------------------------------------------
# -- LOCAL/PRIVATE ROUTINES :
# -----------------------------------------------------------------------------


sub search_menu {

  my $TREE     = shift;
  my $REALNAME = shift;
  my $USERNAME = shift;

    my $string = "";

    $string .= "\n<UL>" .
               "\n<LI><A HREF=\"$cgi_root_dir/search.pl\?" .
               "ACTION=SEARCH_FORM\&TYPE=AD_CONSTRAINTS_ONLY\&" .
               "TREE=$TREE\&USERNAME\=$USERNAME\&REALNAME\=$REALNAME\">" . 
               "Author/date constraints only</A>" .
               "\n</UL>";

    $string .= "\nSearches (below) marked with <B>adc</B> can be used in " .
               "\n conjuction with author/date constraints.";

    $string .= "\n<UL>" .
               "\n<LI><A HREF=\"$cgi_root_dir/search.pl\?" .
               "ACTION=SEARCH_FORM\&TYPE=KEYWORD_SEARCH\&" . 
               "TREE=$TREE\&USERNAME\=$USERNAME\&REALNAME\=$REALNAME\">" . 
               "Keyword Search</A> (adc)";

    $string .= "\n<LI><A HREF=\"$cgi_root_dir/search.pl\?" .
               "ACTION=SEARCH_FORM\&TYPE=GREP_ENTRY_NAMES\&" . 
               "TREE=$TREE\&USERNAME\=$USERNAME\&REALNAME\=$REALNAME\">" . 
               "Grep entry names</A> (adc)";

    $string .= "\n<LI><A HREF=\"$cgi_root_dir/search.pl\?" .
               "ACTION=SEARCH_FORM\&TYPE=GREP_FILE_NAMES\&" . 
               "TREE=$TREE\&USERNAME\=$USERNAME\&REALNAME\=$REALNAME\">" . 
               "Grep file names</A> (adc)";

    $string .= "\n<LI><A HREF=\"$cgi_root_dir/search.pl\?" .
               "ACTION=SEARCH_FORM\&TYPE=SWISH_BRANCH_READMES\&" . 
               "TREE=$TREE\&USERNAME\=$USERNAME\&REALNAME\=$REALNAME\">" . 
               "Swish-e branch READMEs</A>";

    $string .= "\n<LI><A HREF=\"$cgi_root_dir/search.pl\?" . 
               "ACTION=SEARCH_FORM\&TYPE=SWISH_ENTRY_READMES\&" . 
               "TREE=$TREE\&USERNAME\=$USERNAME\&REALNAME\=$REALNAME\">" . 
               "Swish-e Entry READMEs</A> (adc)";

    $string .= "\n<LI><A>File-body search</A>";
    $string .= "\n</UL>";

    return $string;
  }

# -----------------------------------------------------------------------------


sub form_title {

    my $string = "<P><CENTER><FONT FACE=\"helvetica\" SIZE=7><B>" 
        . "Search!" 
        . "</B></FONT></CENTER></P>\n";

    return $string;
  }


# -----------------------------------------------------------------------------


sub form_intro_words {

    my $query  = shift;
    my $string = <<EEOOFF;

    <I>Nota Bene</I>
    <OL>
    <LI>At present, a document/entry has one author and one set of 
        keywords as attributes;  these are associated with all 
        versions of a document. 
    <BR><BR>
    <LI>Only the date of the most recent version of a document is 
        currently 
        considered when applying time constraints.
    <BR><BR>
    <LI>We plan to add more information to <SMALL>HISTORIES</SMALL> 
        to make more sophisticated searching 
        possible<FONT FACE=courier>...</FONT>but don't hold your 
        breath.  For example, each version of an entry will have its 
        own author and  keyword attributes.
    </OL>
EEOOFF

    return $string;
  }


# -----------------------------------------------------------------------------

sub author_and_date_constraints_rows {

  my $except = shift;
  my $query  = shift;
  my $TREE   = shift;
  my $with   = shift;

    my $tree     = Tree->new($except, $TREE);
    my $authors  = $tree->{AUTHORS};

    my $string = "";

$string .= <<EENNDD;

<TR><TD COLSPAN="2" VALIGN="top">
  <FONT FACE="helvetica" SIZE="5"><B>
    Author/Date Constraints
  </B></FONT>
  <BR>
  These constraints may be submitted on their own or in addition 
  to selections set below (leave blank for no constraints).

  <UL>
  <LI>Enter whitespace-separated list of authors to be accepted 
      (note ~s tying name components together), and/or 
  <LI>select lower and upper bounds for dates for documents 
      (<CODE>dd/mm/yyyy, yyyy > 1970</CODE>). 
  </UL>
</TD></TR>

<TR>
  <TD VALIGN="top">

EENNDD


$string .= <<EENNDD;

  <TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0">
    <TR>
      <TD VALIGN="top">
        <FONT FACE="helvetica"><B>Authors:</B><BR>
        <INPUT TYPE="text" NAME="AUTHORS" SIZE="35">
      </TD>
    </TR><TR>
      <TD><BR></TD>
    </TR><TR>
      <TD>
        <FONT FACE="helvetica"><B>Dates (lower/upper):</B>
        <BR>
        <INPUT TYPE="text" NAME="DATELOWER" SIZE="10">
        <INPUT TYPE="text" NAME="DATEUPPER" SIZE="10">
      </TD>
    </TR>
  </TABLE>

EENNDD


$string .= <<EENNDD;

  </TD>
  <TD VALIGN="top" ROWSPAN="2">
    <FONT FACE="helvetica"><B>Existing authors:</B></FONT><BR><BR>
    <TT>

EENNDD

    foreach (sort keys %$authors) {$string .= "$_ / ";}

$string .= <<EENNDD;

    </TT>
    </TD></TR><TR><TD VALIGN="top">
EENNDD

if ($with eq "with") {
    $string .= $query->submit('BUTTON', 'Constraint-only Search');
  }

$string .= <<EENNDD;
  </TD>
</TR>
EENNDD

    return $string;
  }



# -----------------------------------------------------------------------------


sub keywords_rows {

  my $except = shift;
  my $query  = shift;
  my $TREE   = shift;

    my $tree     = Tree->new($except, $TREE);
    my $keywords = $tree->{KEYWORDS};

    my $string = "";
    $string   .= <<EENNDD;
<TR>
  <TD COLSPAN=2 VALIGN="top">
    <FONT FACE="helvetica" SIZE=5><B>Keywords</B></FONT><BR>
    Search on the <SMALL>KEYWORDS</SMALL> attribute of entries;  
    keywords will be Boolean:
    <INPUT TYPE="radio" NAME="KEYWD_BOOLLY" VALUE="AND">
        <B><C>AND</C>ed</B>.
    <INPUT TYPE="radio" NAME="KEYWD_BOOLLY" VALUE="OR" CHECKED>
        <B><C>OR</C>d</B>.
    <UL>
      <LI>Enter a whitespace-separated list of words:
    </UL>
  </TD>
</TR><TR>
  <TD VALIGN="top">
    <FONT FACE="helvetica"><B>Keywords:</B><BR>
    <INPUT TYPE="text" NAME="KEYWORDS" SIZE=35>
  </TD><TD VALIGN="top" ROWSPAN=2>
    <B><FONT FACE="helvetica">Existing keywords:</FONT></B>
    <BR><BR>
    <TT>
EENNDD

    foreach (sort keys %$keywords) {$string .= "$_ / ";}

    $string .= <<EEOOFF;
    </TT>
  </TD>
</TR><TR>
  <TD VALIGN="top">
EEOOFF

    $string .= $query->submit('BUTTON', 'Keyword Search');
    $string .= <<EEOOFF;
  </TD>
</TR>
EEOOFF

    return $string;
  }


# -----------------------------------------------------------------------------


sub grep_entry_names_rows {

    my $query = shift;
    my $string = <<EEOOFF;
<TR>
  <TD COLSPAN=2 VALIGN="top">
    <FONT FACE="helvetica" SIZE=5><B>Entry Names 
               (grep)</B></FONT><BR>
    Do a case-<I>in</I>dependent regular-expression search on 
                   entries (on entry names), for example:
    <UL>
      <LI><TT>^test\sphrase</TT>
      <LI><TT>new*</TT>
    </UL>
  </TD>
</TR><TR>
  <TD VALIGN="top">
    <FONT FACE="helvetica"><B>Regular Exp:</B>
    <BR>
    <INPUT TYPE="text" NAME="ENTRIESGREP" SIZE=35>
  </TD>
</TR><TR>
  <TD VALIGN="top">
EEOOFF

    $string .= $query->submit('BUTTON', 'Grep Entries');
    $string .= <<EEOOFF;
  </TD>
</TR>
EEOOFF

    return $string;
  }



# -----------------------------------------------------------------------------


sub grep_filenames_rows {

    my $query = shift;
    my $string = <<EEOOFF;
<TR>
  <TD COLSPAN=2 VALIGN="top">
    <FONT FACE="helvetica" SIZE=5><B>Filenames (grep)</B></FONT>
    <BR>
    Do a case-<I>in</I>dependent regular-expression search on filenames, 
    for example:
    <UL>
      <LI><TT>^test\sphrase</TT>
      <LI><TT>*new*</TT>
    </UL>
  </TD>
</TR><TR>
  <TD VALIGN="top">
    <FONT FACE="helvetica"><B>Regular Exp:</B><BR>
    <INPUT TYPE="text" NAME="FILENAMESGREP" SIZE=35>
  </TD>
</TR><TR>
  <TD VALIGN="top">
EEOOFF

    $string .= $query->submit('BUTTON', 'Grep Filenames');
    $string .= <<EEOOFF;
  </TD>
</TR>
EEOOFF

    return $string;
  }


# -----------------------------------------------------------------------------


sub swish_branch_readmes_rows{

    my $query  = shift;
    my $string = <<EEOOFF;
<TR>
  <TD COLSPAN=2 VALIGN="top">
    <FONT FACE="helvetica" SIZE=5><B>Branch Readmes: </B></FONT>
    <BR>
    Search the text in branch READMEs:

    <UL>
    <LI>Enter a whitespace-separated list of search words 
        (<B><I>by default these are Boolean ANDed</I></B>).
    <BR><BR>
    <LI><B>Boolean searches</B>: 
        you can use the Boolean operators <B>and</B> 
        <B>or</B>, or <B>not</B> in searching --- without these 
        Boolean operators, it is assumed you're <B>and</B>ing 
        (operators are not case sensitive).  Examples:
      <UL>
        <LI><TT>smilla or snow</TT>, 
        <LI><TT>smilla and snow not sense</TT>,
        <LI><TT>(smilla and snow) and not sense</TT>.
      </UL>
    </UL>
 
  </TD>
</TR><TR>
  <TD COLSPAN=2 VALIGN="top">
    Search of text in Branch <SMALL>README</SMALL>s using SWISH
  </TD>
</TR><TR>
  <TD COLSPAN=2>
    <INPUT TYPE="text" 
           NAME="SRCH_STR_README_Branch" SIZE="60" 
           MAXLENGTH="60">
  </TD>
</TR><TR>
  <TD COLSPAN=2>
EEOOFF

    $string .= $query->submit('BUTTON', 'SWISH Branch READMEs');
    $string .= <<EEOOFF;

  </TD>
</TR>
EEOOFF

    return $string;
  }


# -----------------------------------------------------------------------------

sub swish_entry_readmes_rows{

    my $query  = shift;
    my $string = <<EEOOFF;
<TR>
  <TD COLSPAN=2 VALIGN="top">
    <FONT FACE="helvetica" SIZE=5><B>Entry Readmes: </B></FONT>
    <BR>
    Search of text in Entry <SMALL>README</SMALL>s using SWISH
    <UL>
      <LI>Enter a whitespace-separated list of search words 
          (<B><I>by default these are Boolean ANDed</I></B>).
          <BR><BR>
      <LI><B>Boolean searches</B>: 
          you can use the Boolean operators <B>and</B> 
          <B>or</B>, or <B>not</B> in searching --- without these 
          Boolean operators, it is assumed you're <B>and</B>ing 
          (operators are not case sensitive).  Examples:
      <UL>
        <LI><TT>smilla or snow</TT>, 
        <LI><TT>smilla and snow not sense</TT>,
        <LI><TT>(smilla and snow) and not sense</TT>.
      </UL>
    </UL>
  </TD>
</TR><TR>
  <TD COLSPAN=2>
    <INPUT TYPE="text" 
           NAME="SRCH_STR_README_Entry" SIZE="60" 
           MAXLENGTH="60">
  </TD>
</TR><TR>
  <TD COLSPAN=2>
EEOOFF

    $string .= $query->submit('BUTTON', 'SWISH Entry READMEs');
    $string .= <<EEOOFF;
  </TD>
</TR>
EEOOFF

    return $string;
  }


# -----------------------------------------------------------------------------


sub file_body_search_rows{

    my $string = <<EEOOFF;
<TR>
  <TD COLSPAN=2 VALIGN="top">
    <HR>
    <FONT FACE="helvetica" SIZE=5><B>Bodies: </B></FONT>
  </TD>
</TR><TR>
  <TD VALIGN="top">
    <I>Not yet implemented!</I>
    Search of file text in either definitive and/or view-only 
    document bodies by means of <B>antiword</B>, <B>acroread</B>, 
    <B>ps2text</B>, etc.</TD><TD VALIGN="top">
    [Some hints on successful searching...]
  </TD>
</TR>
EEOOFF

    return $string;
  }


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
