#!/usr/bin/perl -w -I./_login_lib -I./_Doc -I./_cgi_lib -I./_config -I./_sal

# -----------------------------------------------------------------------------

use strict;

# -----------------------------------------------------------------------------
# -- CGI :

use CGI;
use CGI::Carp qw(fatalsToBrowser);


# -----------------------------------------------------------------------------
# -- LIBS :

use config;
use log;

use Cookie;
use Debug;
use Doc;
use Exception;
use Passwd;

# -- ME :
use lf_mod;


# -----------------------------------------------------------------------------
# -- INITIALISE :

my $doc     = Doc->new();
my $cookies = Cookie->new($doc);
my $except  = Exception->new();

my $query   = new CGI;
    # ...pointer to CGI ENV;


# -- read stuff from CGI environment :

my $PASSWORD = $query->param('PASSWORD');
my $REALNAME = $query->param('REALNAME');
my $TREE     = $query->param('TREE');
my $USERNAME = $query->param('USERNAME');


unless (($REALNAME) && ($REALNAME =~ m/\S/)) {
    my $passwd = Passwd->new($except);
    $REALNAME  = $passwd->realname($except, $USERNAME);
  }



# -----------------------------------------------------------------------------
# -- DEBUG :

my $debug = Debug->new(1, "Some important stuff");

$debug->item("username: $USERNAME");
$debug->item("password: $PASSWORD");
$debug->wen($doc);


# -----------------------------------------------------------------------------
# -- DO SOMETHING :

# -- apparently we're trying to login, so check the username and password
#    combination --- if ok set cookie, else logout :

if ($PASSWORD =~ m/\S/) {

    my $passwd = Passwd->new();

    if ($passwd->valid_uname_password($cookies, $doc, $except, 
                                      $USERNAME, $PASSWORD)) {

        my ($key, $value);
        ($key, $value) = $cookies->new_cookie($USERNAME);

        $doc->html_hdr("Set-Cookie: $key=$value; path=/; domain=umist.ac.uk", 
                       "Hello and welcome!", "");
        $doc->doc_hdr("headerstd", $USERNAME, &tree, "/", "???");
	$doc->flush();
        &log_login($USERNAME);
        $doc->append(&motd_and_refresh_text($TREE, $USERNAME, $REALNAME));
        $doc->append("<BR><BR>");
        $doc->wen();
      }
    else {
        $doc->html_hdr("", "Username/Password problem?", "");
        $doc->doc_hdr("headerstd", $USERNAME, &tree, "/", "???");
	$doc->flush();
        $except->raise_logout($cookies, $doc, "dodgy_uname_passwd");
      }
  }
 

# -- default to login-form :
else {
    $doc->html_hdr("", "Login Form", "");
    $doc->doc_hdr("headerstd", "Not logged in yet", &tree, "/", &no_parent);

    # -- display login form for username and corresponding password :
    #
    $doc->append(&form_text());
    $doc->wen();
  }


# -----------------------------------------------------------------------------
# -----------------------------------------------------------------------------




