# -----------------------------------------------------------------------------
package qsm_mod;
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# History :
# 
# -- 2000 Nov 28: 
#          
#    Initial version created on a dark and foul-tempered morn'  Rod has
#    just informed me that it has rained on everyday for a month.  Oh for
#    the Beautiful South...
#    
# -----------------------------------------------------------------------------

use strict;
use vars qw(@ISA @EXPORT);

# -----------------------------------------------------------------------------

require Exporter;

# -----------------------------------------------------------------------------

use CGI;

use config;

# -----------------------------------------------------------------------------

@ISA    = qw(Exporter);
@EXPORT = qw(copy_html_header_to_stdout
             copy_requested_file_to_stdout);


# -----------------------------------------------------------------------------
# -- 
#    

sub copy_html_header_to_stdout() {

  my $doc       = shift @_;
  my $mime_type = shift @_;

    if (($mime_type eq "html") || ($mime_type eq "htm")) {     # ...html
        print "Content-Type: text/html\n\n";
      }
    elsif ($mime_type =~ m/^gif$|^jpeg$|^jpg$|^png$/i) {       # ...images
        print "Content-Type: image/$mime_type\n\n";
      }
    elsif ($mime_type =~ m/^ps$|^eps$/i) {                     # ...eps/ps
        print "Content-type: application/postscript\n\n";
      }
    elsif ($mime_type =~ m/^pdf$/) {                           # ...pdf
        print "Content-type: application/pdf\n\n";
      }
    elsif ($mime_type =~ m/^xls$/) {                           # ...ms-excel
        print "Content-type: application/vnd.ms-excel\n\n";
      }
    elsif ($mime_type =~ m/^doc$/) {                           # ...ms-word
        print "Content-type: application/msword\n\n";
      }
    elsif ($mime_type eq "txt") {                              # ...plain text
        print "Content-type: text/plain\n\n";
      }
    elsif ($mime_type eq "exe") {                              # ...ms windoze exe shite...
        print "Content-type: application/octet-stream\n\n";
      }
    else {
        print "Content-type: application/unknown\n\n";         # ... fall-back
     }
  }


# -----------------------------------------------------------------------------
# --

sub copy_requested_file_to_stdout() {

  my $doc       = shift @_;
  my $mime_file = shift @_;

    my ($line, $type);

    open (FILE, $mime_file);
    while ($line = <FILE>) {
        print $line;
      }
    close(FILE);
  }


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
